Foreman - Bug #15050

ISE on scoped search for Hosts
05/13/2016 05:08 PM - John Mitsch

Status: Closed
Priority: Normal
Assignee: John Mitsch
Category: Search
Target version: 1.11.3
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1335044 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3535
Description

Cloned from https://bugzilla.redhat.com/show_bug.cqgi?id=1335044
Description of problem:
There is a nasty traceback while searching for an existing hostname in Content Hosts using scoped search.

search query: "my-host-1.domain.org"

production.log:

2016-05-11 04:30:59 [app] [I] Processing by Api::V2::HostsController#index as JSON

2016-05-11 04:30:59 [app] [I] Parameters: {"organization_id"=>"1", "page"=>"1", "search"=>"my-host-1.lab.eng.brqg.redhat.com",
"sort_by"=>"name", "sort_order"=>"ASC", "apiv"=>"v2"}

2016-05-11 04:30:59 [app] [W] Action failed | PG::Error: ERROR: missing FROM-clause entry for table "organizations_hosts" |
LINE 1:...14_r9, "taxonomies"."katello_default" AS t14_r10, "organizat...

searching for non-existing hostname works fine.

Version-Release number of selected component (if applicable):
6.2.0 Beta GA10.1

How reproducible:
always

Steps to Reproduce:

1. register a host to your satellite so it appears in Content Hosts
2. Try to put its hostname to the search field and hit search

3. check production.log

Actual results:
ISE

Expected results:
Search query is being validated performed on all applicable fields.

Additional info:

Workaround is to use the explicit-field search query:
name = my-host-1.domain.org or

name ~ my-host-1.domain.org

- I'm requesting a blocker flag for this BZ as this will be hit quite often by users (single word search queries are the most commonly
used)

Associated revisions

Revision b9a3e39d - 05/26/2016 06:21 AM - John Mitsch

Fixes #15050 - Scoped search hostname w/o field no longer ISEs

Searching for an existing host's name without any fields
https://bugzilla.redhat.com/show_bug.cgi?id=1335044

specified results in an SQL error:
missing FROM-clause entry for
table \"organizations_hosts\"

This can be reproduced using
curl -X GET -u admin 'http://localhost:3000/api/v2/
hosts?organization_id=2&search=<hostname>'

where <hostname> is an existing hostname
setting this field to explicit_only will fix the issue

My perspective of what the larger issue is:

This has to do with scoped search using AR's includes®
which generates a sqgl query with a non-existing table,
organization_hosts

This is shown on the command line

Host.includes([:location, :organization])
.where("taxonomies.name" => "org1")
.to_sql.include?("organizations_hosts")
evaluates to true

| am not sure about what to do for a more permanent fix,
it looks like its the same issue as
https://github.com/theforeman/foreman/commit/
5185335248abd0104ec0b791df5e641eeae9dasb

Revision 26678da1 - 06/16/2016 02:14 PM - John Mitsch

Fixes #15050 - Scoped search hostname w/o field no longer ISEs

Searching for an existing host's name without any fields
specified results in an SQL error:

missing FROM-clause entry for

table \"organizations_hosts\"

This can be reproduced using
curl -X GET -u admin 'http://localhost:3000/api/v2/
hosts?organization_id=2&search=<hostname>'

where <hostname> is an existing hostname
setting this field to explicit_only will fix the issue

My perspective of what the larger issue is:

This has to do with scoped search using AR's includes®
which generates a sqgl query with a non-existing table,
organization_hosts

This is shown on the command line

Host.includes([:location, :organization])
.where("taxonomies.name" => "org1")
.to_sql.include?("organizations_hosts")
evaluates to true

| am not sure about what to do for a more permanent fix,
it looks like its the same issue as
https://github.com/theforeman/foreman/commit/
5185335248abd0104ec0b791df5e641eeae9dasb

(cherry picked from commit b9a3e39d0a62b1eda43bb6ce8da54b636¢1500e58)

History

#1 - 05/13/2016 05:14 PM - John Mitsch

To reproduce in foreman use:
curl -X GET -u admin 'http://localhost:3000/api/v2/hosts?organization_id=2&search=&lt;hostnames&qgt; "'
where <hostnames> is an actual host's name.

This seems to be an error in scoped search. If you comment this line out
https://github.com/theforeman/foreman/commit/
https://github.com/theforeman/foreman/commit/

https://github.com/theforeman/foreman/blob/f4459c1/app/models/concerns/hostext/search.rb#L.70

or add :only_explicit => true
that query works.
It seems to be a bug in scoped search that has already caused issues in foreman -

https://github.com/theforeman/foreman/commit/5185335248abd0104ec0b791df5e641eeae9dabb

#2 - 05/16/2016 03:06 AM - Dominic Cleal

- Category changed from Inventory to Search

I'm guessing you've a further search added by a plugin or Katello that adds in joins to taxonomies, and these are conflicting? This doesn't seem to
happen on develop.

#3 - 05/16/2016 02:54 PM - John Mitsch

- Subject changed from ISE on scoped search for Content Hosts to ISE on scoped search for Hosts

I've tested and was able to recreate this on just a foreman (no katello or plugins) development environment.

Did you test that curl command using a host that had been already created? It only errors when you search for an actual host.
i.e. curl -X GET -u admin 'http://localhost:3000/api/v2/hosts?organization_id=2&search=myhost.example.com’

#4 - 05/18/2016 11:14 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to John Mitsch

- Pull request https://github.com/theforeman/foreman/pull/3535 added

#5 - 05/26/2016 07:01 AM - John Mitsch
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset b9a3e39d0a62b1eda43b6ce8da54b636c1500e58.

#6 - 05/27/2016 04:46 AM - Dominic Cleal

- translation missing: en.field_release set to 159
